<template>
    <div class="border border-br flex flex-col" :style="styles">
        <vue-ueditor-wrap
            :editor-id="name"
            :config="editorConfig"
            v-model="valueHtml"
            @beforeInit="addCustomDialog"
        ></vue-ueditor-wrap>
        <material-picker
            ref="materialPickerRef"
            :type="fileType"
            :limit="-1"
            hidden-upload
            @change="selectChange"
        />
    </div>
</template>
<script setup lang="ts">
import MaterialPicker from '@/components/material/picker.vue'
import { addUnit } from '@/utils/util'
import type { CSSProperties } from 'vue'

const props = withDefaults(
    defineProps<{
        modelValue?: string
        mode?: 'default' | 'simple'
        height?: string | number
        width?: string | number
        name?: string
    }>(),
    {
        modelValue: '',
        mode: 'default',
        height: '100%',
        width: 'auto',
        name: 'ueditor_tutu'
    }
)

// 这里使用百度编辑器添加的配置
const editorConfig = {
    autoHeightEnabled: false,
    initialFrameHeight: props.height,
    initialFrameWidth: '100%',
    UEDITOR_HOME_URL: '/ueditor/',
    enableAutoSave: true
}

const emit = defineEmits<{
    (event: 'update:modelValue', value: string): void
}>()

// 编辑器实例，必须用 shallowRef
shallowRef()
const materialPickerRef = shallowRef<InstanceType<typeof MaterialPicker>>()
const fileType = ref('')
const imageUrl = []
// 这里使用const，避免每次调用富文本组件的时候，都去创建一次自定义按钮事件。
var editorInstance = shallowRef()

const addCustomDialog = () => {
    window.UE.registerUI(
        'ueditor',
        function (editor, uiName) {
            // 创建 dialog
            const dialog = new window.UE.ui.Dialog({
                // 指定弹出层中页面的路径，这里只能支持页面，路径参考常见问题 2
                //iframeUrl: '/article/material/index?field=dialog',
                // 需要指定当前的编辑器实例
                editor: editor,
                // 指定 dialog 的名字
                name: uiName,
                // dialog 的标题
                title: '上传图片',
                // 指定 dialog 的外围样式
                cssRules: 'width:1000px;height:620px;padding:20px;'
            })
            this.dialog = dialog
            const btn = new window.UE.ui.Button({
                name: 'dialog-button',
                title: '上传图片',
                cssRules: `background-image: url(@/assets/images/icons.png);background-position: -726px -77px;`,
                onclick: function () {
                    // 渲染dialog
                    // dialog.render()
                    // dialog.open()
                    customBrowseAndUpload()
                    editorInstance = editor
                    console.log(editorInstance)
                    // editor.execCommand('inserthtml', );
                }
            })
            return btn
        },
        37
    )
}

// 显示文件弹窗
const customBrowseAndUpload = () => {
    fileType.value = 'image'
    materialPickerRef.value?.showPopup(-1)
}

const styles = computed<CSSProperties>(() => ({
    height: addUnit(props.height),
    width: addUnit(props.width)
}))
const valueHtml = computed({
    get() {
        return props.modelValue
    },
    set(value) {
        emit('update:modelValue', value)
    }
})

const selectChange = (fileUrl: string[]) => {
    fileUrl.forEach((url) => {
        editorInstance.execCommand("inserthtml", '<img src="'+url+'" style="height: 200px !important;">')
        imageUrl.push(url)
    })
}

</script>

<style lang="scss">
.w-e-full-screen-container {
    z-index: 999;
}
.w-e-text-container [data-slate-editor] ul {
    list-style: disc;
}
.w-e-text-container [data-slate-editor] ol {
    list-style: decimal;
}
h1 {
    font-size: 2em;
}
h2 {
    font-size: 1.5em;
}
h3 {
    font-size: 1.17em;
}
h4 {
    font-size: 1em;
}
h5 {
    font-size: 0.83em;
}
h1,
h2,
h3,
h4,
h5 {
    font-weight: bold;
}
</style>
